*
* Mean 18
* (c) 1987, Accolade
* (s) 2019, Brutal Deluxe Software
*

	mx	%00
	rel
	lst	off

*-----------------------------------

	use	SEG4.E.S
	use	SEG4.X.S
	
	use	4/Mem.Macs
	use	4/Misc.Macs
	use	4/QD.Macs
	use	4/Sound.Macs
	use	4/Util.Macs
	
*-----------------------------------

L0400C1  ENT
         PHD
         PHB
         TSC
         TCD
         SEC
         SBC   #$0078
         STAL  L0400E8+1
         STAL  L0400DA+1
         LDX   #$0000
         SEP   #$20
L0400D6  LDAL  L0400F7,X
L0400DA  STAL  $00FFFF,X
         INX
         CPX   #$0064
         BCC   L0400D6
         REP   #$20
         LDY   $07
L0400E8  JSL   $000000
         LDA   #$0000
         BCC   L0400F4
         LDA   #$0001
L0400F4  PLB
         PLD
         RTL

L0400F7  TSC		; Print routine at $00/0000!!
         TAX
         SEP   #$20
         XBA
         DEC
         BEQ   L040105
         LDA   #$01
         XBA
         LDA   #$FF
         TCS
L040105  PHX
         SEC
         XCE
         PEA   $0000
         PLD
         LDA   #$00
         PHA
         PLB
         SEP   #$30
         DEY
         BEQ   L040123
         DEY
         BEQ   L04012B
         LDA   $C10F
         STA   $0101
         INY
         INY
         TYA
         BRA   L040133
L040123  LDA   $C10D
         STA   $0101
         BRA   L040133
L04012B  LDA   $C110
         STA   $0101
         LDA   #$00
L040133  LDX   #$20
         STX   $0100
         LDX   #$C1
         STX   $0102
         LDX   #$60
         STX   $0103
         LDX   $C082
         LDX   #$C1
         LDY   #$10
         JSR   $0100
         LDX   $C083
         LDX   $C083
         PHP
         CLC
         XCE
         PLP
         REP   #$30
         PLX
         TXS
         RTL

L04015B  ENT
         PHD
         TSC
         TCD
         LDA   $06
         sta   L026350
         LDA   $08
         sta   L026352
         JSL   GSOS
         DW    $0002      ; Destroy
         ADRL  L026350
         PLD
         RTL

L040176  ENT
         CLI
         RTL

L040248  ENT
         PHD
         TSC
         TCD
         LDX   $06
         LDY   $08
         LDA   $0A
         PHX
         PHA
         PHY
         _FFStartSound
         PLD
         RTL

L04025D  ENT
         PHD
         TSC
         TCD
         LDA   $06
         PHA
         _FFStopSound
         PLD
         RTL

L040293  ENT
         REP   #$30
         PHB
         PHD
         TSC
         TCD
         LDA   $0D,S
         TAY
         DEY
         SEP   #$20
         LDA   $0B,S
L0402A1  STA   [$07],Y
         DEY
         BPL   L0402A1
         REP   #$20
         PLD
         PLB
         RTL

L0402AB  ENT
         REP   #$30
         LDA   $06,S
         CMP   $0A,S
         BCC   L0402BB
         BNE   L0402E0		; call MVP
         LDA   $04,S
         CMP   $08,S
         BCS   L0402E0		; call MVP
L0402BB  SEP   #$20
         LDA   #$54		; MVN
         STAL  L040313
         LDA   $06,S
         STAL  L040314
         LDA   $0A,S
         STAL  L040315
         REP   #$20
         LDA   $08,S
         TAX
         LDA   $04,S
         TAY
         LDA   $0C,S
         SEC
         SBC   #$0001
         JMP   L040312

L0402E0  REP   #$20
         LDA   $0C,S
         SEC
         SBC   #$0001
         CLC
         ADC   $08,S
         TAX
         LDA   $0C,S
         SEC
         SBC   #$0001
         CLC
         ADC   $04,S
         TAY
         SEP   #$20
         LDA   #$44		; MVP
         STAL  L040313
         LDA   $06,S
         STAL  L040314
         LDA   $0A,S
         STAL  L040315
         REP   #$20
         LDA   $0C,S
         SEC
         SBC   #$0001
L040312  PHB
L040313  DB    $00
L040314  DB    $00
L040315  DB    $00
         PLB
         RTL

L040318  ENT
         REP   #$30
         LDA   $06,S
         RTL

L04031D  ENT
         REP   #$30
         PHD
         TSC
         TCD
         LDA   $08
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $06
         adc   L0211C6
         STA   $06
         lda   L0211C8
         ADC   #$0000
         STA   $08
	 lda   [$06]
	 and   #$000f
	 pld
	 rtl

L040349  ENT
         REP   #$30
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $0C
         ASL
         TAX
         LDA   $0A
         LSR
         CLC
         adc   L021030,X
         adc   L0211C6
         STA   $01
         lda   L0211C8
         ADC   #$0000
         STA   $03
         LDA   $0A
         AND   #$0001
         BEQ   L040380
	 lda   [$01]
	 and   #$fff0
	 ora   $0e
	 sta   [$01]
	 pld
	 pld
	 pld
	 rtl
L040380  lda   $0e
	 asl
	 asl
	 asl
	 asl
	 sta   $0e
	 lda   [$01]
	 and   #$ff0f
	 ora   $0e
	 sta   [$01]
	 pld
	 pld
	 pld
	 rtl
	
L040398  ENT
         REP   #$30
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $0C
         ASL
         TAX
         LDA   $0A
         LSR
         CLC
         adc   L021030,X
         adc   L0211C6
         STA   $01
         lda   L0211C8
         ADC   #$0000
         STA   $03
         LDA   $0A
         AND   #$0001
         BEQ   L0403CB
	 lda   [$01]
	 and   #$000f
	 pld
	 pld
	 pld
	 rtl
L0403CB  lda   [$01]
	 lsr
	 lsr
	 lsr
	 lsr
	 and   #$000f
	 pld
	 pld
	 pld
	 rtl

L0403DB  ENT
         REP   #$30
         PHD
         TSC
         TCD
         LDA   $08
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $06
         adc   L0211C6
         STA   $06
         lda   L0211C8
         ADC   #$0000
         STA   $08
         LDX   $0A
         SEP   #$20
         lda   L023DBE,X
         STA   [$06]
         REP   #$20
         PLD
         RTL

L040408  ENT
         REP   #$30
         PHD
         TSC
         TCD
         LDA   $08
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $06
         adc   L0211C6
         STA   $06
         lda   L0211C8
         ADC   #$0000
         STA   $08
         SEP   #$20
         LDA   [$06]
         EOR   #$FF
         STA   [$06]
         REP   #$20
         PLD
         RTL

L040433  ENT
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $0C
         AND   #$00FE
         STA   $0C
         LDA   $12
         CLC
         ADC   $0E
         STA   $12
L040447  LDA   $0E
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $0C
         adc   L0211C6
         STA   $01
         lda   L0211C8
         ADC   #$0000
         STA   $03
         LDA   $10
         STA   $05
L040465  SEP   #$30
         LDA   [$14]
         TAY
         LSR
         LSR
         LSR
         LSR
         TAX
         lda   L023DBE,X
         STA   [$01]
         REP   #$30
         INC   $01
         BNE   L04047D
         INC   $03
L04047D  SEP   #$30
         TYA
         AND   #$0F
         TAX
         lda   L023DBE,X
         STA   [$01]
         REP   #$30
         INC   $01
         BNE   L040491
         INC   $03
L040491  INC   $14
         BNE   L040497
         INC   $16
L040497  DEC   $05
         BNE   L040465
         INC   $0E
         LDA   $0E
         CMP   $12
         BCS   L0404A7
         JMPL  L040447
L0404A7  PLD
         PLD
         PLD
         PLD
         RTL

L0404AC  ENT
         PHD
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $0E
         AND   #$00FE
         STA   $0E
         LDA   $14
         CLC
         ADC   $10
         STA   $14
L0404C1  LDA   $10
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $0E
         adc   L0211C6
         STA   $01
         lda   L0211C8
         ADC   #$0000
         STA   $03
         LDA   $12
         STA   $05
L0404DF  SEP   #$30
         LDA   [$01]
         ASL
         ASL
         ASL
         ASL
         STA   $07
         REP   #$30
         INC   $01
         BNE   L0404F1
         INC   $03
L0404F1  SEP   #$30
         LDA   [$01]
         AND   #$0F
         ORA   $07
         STA   [$16]
         REP   #$30
         INC   $01
         BNE   L040503
         INC   $03
L040503  INC   $16
         BNE   L040509
         INC   $18
L040509  DEC   $05
         BNE   L0404DF
         INC   $10
         LDA   $10
         CMP   $14
         BCS   L040519
         JMPL  L0404C1
L040519  PLD
         PLD
         PLD
         PLD
         PLD
         RTL

L04051F  ENT
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $12
         CLC
         ADC   $0E
         STA   $12
         LDA   $0C
         LSR
         STA   $0C
         LDA   $10
         CLC
         ADC   #$0001
         LSR
*         STA   $10
	 tay
L04053A  LDA   $0E
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $0C
         adc   L0211C6
         STAL  L040575+1
         lda   L0211C8
         ADC   #$0000
         SEP   #$20
         STAL  L040575+3
         LDA   $16
         STAL  L040571+3
         REP   #$20
         LDA   $14
         STAL  L040571+1
*         LDA   $10
	 tya
         SEC
         SBC   #$0001
         TAX
         SEP   #$20
L040571  LDAL  $000000,X
L040575  STAL  $000000,X
         DEX
         BPL   L040571
         REP   #$20
         CLC
*         LDA   $10
	 tya
         ADC   $14
         STA   $14
         LDA   $16
         ADC   #$0000
         STA   $16
         INC   $0E
         LDA   $0E
         CMP   $12
         BCC   L04053A
         PLD
         PLD
         PLD
         PLD
         RTL

L040599  ENT
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $12
         CLC
         ADC   $0E
         STA   $12
         LDA   $0C
         LSR
         STA   $0C
         LDA   $10
         CLC
         ADC   #$0001
         LSR
*         STA   $10
	 tay
L0405B4  LDA   $0E
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $0C
         adc   L0211C6
         STAL  L0405EB+1
         lda   L0211C8
         ADC   #$0000
         SEP   #$20
         STAL  L0405EB+3
         LDA   $16
         STAL  L0405EF+3
         REP   #$20
         LDA   $14
         STAL  L0405EF+1
*         LDA   $10
	 tya
         SEC
         SBC   #$0001
         TAX
         SEP   #$20
L0405EB  LDAL  $000000,X
L0405EF  STAL  $000000,X
         DEX
         BPL   L0405EB
         REP   #$20
         CLC
*         LDA   $10
	 tya
         ADC   $14
         STA   $14
         LDA   $16
         ADC   #$0000
         STA   $16
         INC   $0E
         LDA   $0E
         CMP   $12
         BCC   L0405B4
         PLD
         PLD
         PLD
         PLD
         RTL

L04068F  ENT
         PHD
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $0E
         AND   #$00FE
         STA   $0E
         LDA   $10
         CLC
         ADC   $14
         STA   $14
         LDA   $12
         ASL
         STA   $12
L0406A9  LDA   $10
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $0E
         adc   L0211C6
         STA   $01
         lda   L0211C8
         ADC   #$0000
         STA   $03
         LDX   $16
         SEP   #$20
         lda   L023DBE,X
         LDY   $12
         DEY
L0406CE  STA   [$01],Y
         DEY
         BPL   L0406CE
         REP   #$20
         INC   $10
         LDA   $10
         CMP   $14
         BCC   L0406A9
         PLD
         PLD
         PLD
         PLD
         PLD
         RTL

L0406E3  PHD
         PHD
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         STX   $01
         STY   $03
         LDA   #$0000
         STA   $05
         STA   $07
         STA   $09
L0406F8  LSR   $01
         BCC   L040709
         CLC
         LDA   $07
         ADC   $03
         STA   $07
         LDA   $09
         ADC   $05
         STA   $09
L040709  ASL   $03
         ROL   $05
         LDA   $01
         BNE   L0406F8
         LDA   $07
         LDX   $09
         PLD
         PLD
         PLD
         PLD
         PLD
         PLD
         RTL

L04071C  ENT
         PHD
         TSC
         TCD
         LDY   $06
         LDX   $08
         JSL   L0406E3
         STA   $06
         STX   $08
         LDA   $07
         PLD
         RTL

L04072F  ENT
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
*         LDA   #$0000
*         STA   $01
	 stz   $01
         LDA   #$8000
         STA   $03
L04073F  LDA   $01
         ORA   $03
         TAX
         TAY
         JSL   L0406E3
         CPX   $0E
         BCC   L040755
         BNE   L04075B
         CMP   $0C
         BCC   L040755
         BNE   L04075B
L040755  LDA   $01
         ORA   $03
         STA   $01
L04075B  LSR   $03
         BCC   L04073F
         LDA   $01
         PLD
         PLD
         PLD
         PLD
         RTL

L040766  ENT
*         PHD
*         TSC
*         SEC
*         SBC   #$00FB
*         TCD
*         ADC   #$00F6
*         TCS
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L026412
*         TDC
*         CLC
*         ADC   #$00FB
*         TCS
*         PLD
         RTL

L040783  ENT
*         PHD
*         TSC
*         SEC
*         SBC   #$00FB
*         TCD
*         ADC   #$00F6
*         TCS
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L026412
*         TDC
*         CLC
*         ADC   #$00FB
*         TCS
*         PLD
         RTL

L0407A0  ENT
*         PHD
*         TSC
*         SEC
*         SBC   #$00FB
*         TCD
*         ADC   #$00F6
*         TCS
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L02641C
*         TDC
*         CLC
*         ADC   #$00FB
*         TCS
*         PLD
         RTL

L0407BD  ENT
         PHD
         PHD
         PHD
         PHD
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $12
         AND   #$0007
         ASL
         ASL
         ASL
         ASL
         STA   $01
         stz   $03
         lda   L020804
         STA   $09
         lda   L020806
         STA   $0B
         LDY   #$00AE
L0407E5  lda   L021235
         AND   #$00FF
         TAX
         lda   L021231
         AND   #$00FF
         STA   $05
         CMP   #$0080
         BCS   L040808
         CPX   #$0040
         BCC   L04080F
L040808  LDA   #$0000
         INC   $03
         BNE   L040836
L04080F  TXA
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         CLC
         ADC   $05
         PHY
         TAY
         LDA   [$09],Y
         PLY
         AND   #$000F
         ASL
         TAX
         lda   L0239F2,X
         AND   #$0007
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
L040836  CLC
         ADC   $01
         STA   $07
         TYA
         AND   #$000F
         CLC
         ADC   $07
         TAX
         SEP   #$20
         lda   L023A12,X
         STA   $07
         STY   $05
         LDX   $05
         LDA   $12
         LSR
         BCS   L04085E
         LDA   $07
         sta   L0200DE,X
         JMPL  L040864

L04085E  LDA   $07
         sta   L02018D,X
L040864  REP   #$20
         LDA   $03
         BNE   L0408CF
         CPY   #$00A6
         BCS   L0408CF
         lda   L02122E
         adc   L021236
         sta   L02122E
         lda   L021230
         adc   L021238
         sta   L021230
         lda   L021232
         adc   L02123A
         sta   L021232
         lda   L021234
         adc   L02123C
         sta   L021234
         lda   L021236
         adc   L02123E
         sta   L021236
         lda   L021238
         adc   L021240
         sta   L021238
         lda   L02123A
         adc   L021242
         sta   L02123A
         lda   L02123C
         adc   L021244
         sta   L02123C
L0408CF  DEY
         CPY   #$0014
         BCC   L0408D9
         JMPL  L0407E5
L0408D9  PLD
         PLD
         PLD
         PLD
         PLD
         PLD
         PLD
         RTL

L0408E1  ENT
         PHD
         PHD
         PHD
         TSC
         TCD
         LDA   $0A
         LSR
         STA   $0A
         LDA   $0E
         CLC
         ADC   #$0001
         LSR
         STA   $0E
         LDA   $0C
         CLC
         ADC   $10
         STA   $10
L0408FB  LDA   $0C
         ASL
         TAX
         lda   L021030,X
         CLC
         ADC   $0A
         adc   L0211C6
         STA   $01
         lda   L0211C8
         ADC   #$0000
         STA   $03
         LDY   $0E
         DEY
L040918  LDA   #$0000
         SEP   #$20
         LDA   [$12]
         TAX
         LDA   [$16]
         and   L023DDA,X
         ora   L023EDA,X
         STA   [$01]
         REP   #$20
         INC   $01
         BNE   L040934
         INC   $03
L040934  INC   $12
         BNE   L04093A
         INC   $14
L04093A  INC   $16
         BNE   L040940
         INC   $18
L040940  DEY
         BPL   L040918
         INC   $0C
         LDA   $0C
         CMP   $10
         BCC   L0408FB
         PLD
         PLD
         PLD
         RTL

L04094F  ENT
         PHD
         TSC
         TCD
         LDA   $06
         STAL  L040970
         LDA   $08
         STAL  L040970+2
         LDA   $0A
         STAL  L040974
         JSL   GSOS
         DW    $0029      ; Quit
         ADRL  L040970
         PLD
         RTL

L040970  ADRL  $00000000  ;  path name
L040974  DW    $0000      ;  flags

L040976  ENT
         PHD
         TSC
         TCD
         LDA   $06
         STAL  L040993
         LDA   $08
         STAL  L040993+2
         JSL   GSOS
         DW    $0009      ; SetPrefix
         ADRL  L040991
         PLD
         RTL

L040991  DW    $0000      ;  prefix num
L040993  ADRL  $00000000  ;  prefix ptr

L040997  ENT
         PHD
         TSC
         TCD
         LDA   $06
         sta   L02643E
         LDA   $08
         sta   L026440
         JSL   GSOS
         DW    $0008      ; Volume
         ADRL  L02643E
         PLD
         RTL

L0409B2  ENT
         PHD
         TSC
         TCD
         LDY   $0A
         DEY
         LDA   #$0000
         SEP   #$20
L0409BD  LDA   [$06],Y
         TAX
         lda   L02023C,X
         STA   [$06],Y
         DEY
         BPL   L0409BD
         REP   #$20
         PLD
         RTL
